package com.muyu.cloud.etl.controller;

import com.muyu.cloud.etl.service.StructureService;
import com.muyu.cloud.etl.service.TableInfoService;
import com.muyu.common.core.domain.Result;
import com.muyu.domain.Structure;
import com.muyu.domain.TableInfo;
import com.muyu.domain.rep.TableInfoRep;
import com.muyu.domain.rep.TableInfoTreeRep;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.List;

@RestController
@RequestMapping("/tableInfo")
public class TableInfoController {
    @Autowired
    private TableInfoService tableInfoService;
    @Autowired
    private StructureService structureService;

    @GetMapping("/findTableInfo")
    public Result<List<TableInfoTreeRep>> findTableInfo() {
          List<TableInfo> tableInfoList= tableInfoService.findSourceList();

        List<TableInfoTreeRep> tableInfoTreeReps = new ArrayList<TableInfoTreeRep>();

        for (TableInfo tableInfo : tableInfoList) {
            TableInfoTreeRep tableInfoTreeRep = new TableInfoTreeRep();
            tableInfoTreeRep.setTableInfo(tableInfo);
            List<TableInfoRep> tableInfoRepList=  tableInfoService.findTablesList(tableInfo.getId());
            tableInfoTreeRep.setChildren(tableInfoRepList);
            for (TableInfoRep tableInfoRep : tableInfoRepList) {
                List<Structure> structureList=structureService.findStructureList(tableInfoRep.getId());
                tableInfoRep.setStructureList(structureList);
            }
            tableInfoTreeReps.add(tableInfoTreeRep);
        }

        return Result.success(tableInfoTreeReps);

    }
}
